import javax.microedition.lcdui.*;
import java.util.Date;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;

public class optionsForm extends Form implements CommandListener,ItemStateListener {
 private midlet midlet;
 private midletCanvas midletCanvas;
 private Display dpy;
 private Displayable prev;
 private options options;
 private Timer timer=null;
 private formTimerTask timertask=null;

 private Command cmdCancel,cmdOK;
 private DateField time1,time2;
 private TextField min,sec,volume;
 private ChoiceGroup vibra, curants, sound, fromhour, style;
 private String [] sounds = { "", "", "", "" };
 private String [] times = {" ", ""};
 private String [] styles = {"", ""};

 public optionsForm (midlet midlet, midletCanvas midletCanvas) {
  super("");
  this.midlet = midlet;
  this.midletCanvas=midletCanvas;
  dpy = Display.getDisplay(midlet);
  prev = dpy.getCurrent();
  options = new options (false);
  cmdCancel = new Command ("", Command.CANCEL, 0);
  cmdOK = new Command ("OK", Command.OK, 1);

  Calendar cal=Calendar.getInstance();
  Date dt=new Date(0);
  cal.setTime(dt);
  time1=new DateField (" :",DateField.TIME);
  cal.set(Calendar.HOUR_OF_DAY,options.starthour);
  cal.set(Calendar.MINUTE,options.startmin);
  dt=cal.getTime();
  time1.setDate(dt);
  time2=new DateField (" :",DateField.TIME);
  cal.set(Calendar.HOUR_OF_DAY,options.endhour);
  cal.set(Calendar.MINUTE,options.endmin);
  dt=cal.getTime();
  time2.setDate(dt);

  min=new TextField (" , .",""+options.mininterval,3,TextField.NUMERIC);
  sec=new TextField (" , .",""+options.secinterval,2,TextField.NUMERIC);

  sound = new ChoiceGroup ("", ChoiceGroup.EXCLUSIVE, sounds, null);
  sound.setSelectedIndex (options.sound, true);

  volume=new TextField (" (0-9)",""+options.volume,1,TextField.NUMERIC);

  vibra=new ChoiceGroup ("", ChoiceGroup.MULTIPLE);
  vibra.append ("  ", null); 
  if (options.vibrator!=0) vibra.setSelectedIndex (0,true);
  else vibra.setSelectedIndex (0,false);
  curants = new ChoiceGroup ("", ChoiceGroup.MULTIPLE);
  curants.append ("  ", null); 
  if (options.curants!=0) curants.setSelectedIndex (0,true);
  else curants.setSelectedIndex (0,false);

  fromhour=new ChoiceGroup ("  :", ChoiceGroup.EXCLUSIVE, times, null);
  fromhour.setSelectedIndex (options.fromhour,true);

  style=new ChoiceGroup (" :", ChoiceGroup.EXCLUSIVE, styles, null);
  style.setSelectedIndex (options.style,true);

  append (time1);
  append (fromhour);
  append (time2);
  append (min);
  append (sound);
  append (curants);
  append (volume);
  append (vibra);
  append (sec);
  append (style);
  addCommand(cmdCancel); addCommand(cmdOK);

  timer = new Timer();
  timertask = new formTimerTask (timer, dpy, prev, midletCanvas);
  timer.scheduleAtFixedRate (timertask,0,(long)midlet.timerInterval);

  setItemStateListener (this);
  setCommandListener (this);
 }

 public void commandAction(Command c, Displayable d) {
  if (c == cmdCancel) {
   dpy.setCurrent(prev);
  }
  else if (c==cmdOK) {
   Calendar cal=Calendar.getInstance(); 
   Date dt=new Date(0); 
   cal.setTime(dt);
   dt=time1.getDate();
   cal.setTime (dt);
   options.starthour=cal.get (Calendar.HOUR_OF_DAY);
   options.startmin=cal.get (Calendar.MINUTE);
   dt=time2.getDate();
   cal.setTime (dt);
   options.endhour=cal.get (Calendar.HOUR_OF_DAY);
   options.endmin=cal.get (Calendar.MINUTE);
   options.sound = sound.getSelectedIndex ();
   if (curants.isSelected(0)==true) options.curants=1; else options.curants=0;
   if (vibra.isSelected(0)==true) options.vibrator=1; else options.vibrator=0;
   options.fromhour=fromhour.getSelectedIndex ();
   options.style=style.getSelectedIndex ();

   int v=options.volume;
   try {
    v=Integer.parseInt(volume.getString().trim());
   }
   catch (NumberFormatException n) {
    dpy.setCurrent (new Alert ("","  0  9!",null,AlertType.INFO),dpy.getCurrent());
    return;
   }
   options.volume=v;

   int m=options.mininterval,s=options.secinterval;
   try {
    m=Integer.parseInt(min.getString().trim());
    s=Integer.parseInt(sec.getString().trim());
   }
   catch (NumberFormatException n) {
    dpy.setCurrent (new Alert (""," -  !",null,AlertType.INFO),dpy.getCurrent());
    return;
   }
   if ((s<1) || (m<1)) {
    dpy.setCurrent (new Alert ("","   !",null,AlertType.INFO),dpy.getCurrent());
    return;
   }
   options.mininterval=m;
   options.secinterval=s;
   dpy.setCurrent(prev);
   options.changed=true;
  }
  timertask.counter=0;
  timertask.cancel ();
  timer.cancel ();
  midletCanvas.first=true;
  midletCanvas.repaint ();
 }

 public void itemStateChanged (Item item) {
  timertask.counter=0;  
 }

}